import { Component, instantiate, Node, Prefab, _decorator } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('Create')
export class Create extends Component {
    @property(Prefab)
    pfbPure!: Prefab;
    @property(Prefab)
    pfbPhys!: Prefab;
    
    @property(Node)
    nodePure!: Node;
    @property(Node)
    nodePhys!: Node;

    start() {
        let time = Date.now()
        for (let i = 0; i < 100; i++) {
            let node = instantiate(this.pfbPure)
            this.nodePure.addChild(node)
        }
        console.log("pure create", Date.now() - time)
        time = Date.now()

        for (let i = 0; i < 100; i++) {
            let node = instantiate(this.pfbPhys)
            this.nodePhys.addChild(node)
        }
        console.log("phys create", Date.now() - time)


        let count = 0
        setInterval(() => {
            count++
            if(count % 2 == 0){
                this.show()
            }else{
                this.hide()
            }
        }, 2000)
    }

    show(){
        let time = Date.now()
        this.nodePure.active = true
        console.log("pure show", Date.now() - time)

        time = Date.now()
        this.nodePhys.active = true
        console.log("phys show", Date.now() - time)
    }
    
    hide(){
        let time = Date.now()
        this.nodePure.active = false
        console.log("pure hide", Date.now() - time)

        time = Date.now()
        this.nodePhys.active = false
        console.log("phys hide", Date.now() - time)
    }
}

